tclap: TCLAP::UnlabeledValueArg< T > Class Template Reference

tclap 1.2.5

Public Member Functions | List of all members
TCLAP::UnlabeledValueArg< T > Class Template Reference

The basic unlabeled argument that parses a value. More...

`#include <UnlabeledValueArg.h>`

Inheritance diagram for TCLAP::UnlabeledValueArg< T >:
[legend]
Collaboration diagram for TCLAP::UnlabeledValueArg< T >:
[legend]

## Public Member Functions
| UnlabeledValueArg (const std::string &name, const std::string &desc, bool req, T value, const std::string &typeDesc, bool ignoreable=false, Visitor *v=NULL)
| UnlabeledValueArg constructor. More...
| UnlabeledValueArg (const std::string &name, const std::string &desc, bool req, T value, const std::string &typeDesc, CmdLineInterface &parser, bool ignoreable=false, Visitor *v=NULL)
| UnlabeledValueArg constructor. More...
| UnlabeledValueArg (const std::string &name, const std::string &desc, bool req, T value, Constraint< T > *constraint, bool ignoreable=false, Visitor *v=NULL)
| UnlabeledValueArg constructor. More...
| UnlabeledValueArg (const std::string &name, const std::string &desc, bool req, T value, Constraint< T > *constraint, CmdLineInterface &parser, bool ignoreable=false, Visitor *v=NULL)
| UnlabeledValueArg constructor. More...
virtual bool | processArg (int *i, std::vector< std::string > &args)
| Handles the processing of the argument. More...
virtual std::string | shortID (const std::string &val="val") const
| Overrides shortID for specific behavior. More...
virtual std::string | longID (const std::string &val="val") const
| Overrides longID for specific behavior. More...
virtual bool | operator== (const Arg &a) const
| Overrides operator== for specific behavior. More...
virtual void | addToList (std::list< Arg * > &argList) const
| Instead of pushing to the front of list, push to the back. More...
Public Member Functions inherited from TCLAP::ValueArg< T >
| ValueArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, T value, const std::string &typeDesc, Visitor *v=NULL)
| Labeled ValueArg constructor. More...
| ValueArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, T value, const std::string &typeDesc, CmdLineInterface &parser, Visitor *v=NULL)
| Labeled ValueArg constructor. More...
| ValueArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, T value, Constraint< T > *constraint, CmdLineInterface &parser, Visitor *v=NULL)
| Labeled ValueArg constructor. More...
| ValueArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, T value, Constraint< T > *constraint, Visitor *v=NULL)
| Labeled ValueArg constructor. More...
const T & | getValue () const
| Returns the value of the argument. More...
T & | getValue ()
| operator const T & () const
| A ValueArg can be used as as its value type (T) This is the same as calling getValue() More...
virtual void | reset ()
| Clears the Arg object and allows it to be reused by new command lines. More...
Public Member Functions inherited from TCLAP::Arg
virtual | ~Arg ()
| Destructor. More...
const std::string & | getFlag () const
| Returns the argument flag. More...
const std::string & | getName () const
| Returns the argument name. More...
std::string | getDescription () const
| Returns the argument description. More...
virtual bool | isRequired () const
| Indicates whether the argument is required. More...
void | forceRequired ()
| Sets _required to true. More...
void | xorSet ()
| Sets the _alreadySet value to true. More...
bool | isValueRequired () const
| Indicates whether a value must be specified for argument. More...
bool | isSet () const
| Indicates whether the argument has already been set. More...
bool | isIgnoreable () const
| Indicates whether the argument can be ignored, if desired. More...
virtual bool | argMatches (const std::string &s) const
| A method that tests whether a string matches this argument. More...
virtual std::string | toString () const
| Returns a simple string representation of the argument. More...
virtual void | trimFlag (std::string &flag, std::string &value) const
| Trims a value off of the flag. More...
bool | _hasBlanks (const std::string &s) const
| Checks whether a given string has blank chars, indicating that it is a combined SwitchArg. More...
void | setRequireLabel (const std::string &s)
| Sets the requireLabel. More...
virtual bool | allowMore ()
| Used for MultiArgs and XorHandler to determine whether args can still be set. More...
virtual bool | acceptsMultipleValues ()
| Use by output classes to determine whether an Arg accepts multiple values. More...

## Additional Inherited Members
Static Public Member Functions inherited from TCLAP::Arg
static void | beginIgnoring ()
| Begin ignoring arguments since the "--" argument was specified. More...
static bool | ignoreRest ()
| Whether to ignore the rest. More...
static char | delimiter ()
| The delimiter that separates an argument flag/name from the value. More...
static char | blankChar ()
| The char used as a place holder when SwitchArgs are combined. More...
static char | flagStartChar ()
static const std::string | flagStartString ()
static const std::string | nameStartString ()
static const std::string | ignoreNameString ()
| The name used to identify the ignore rest argument. More...
static void | setDelimiter (char c)
| Sets the delimiter for all arguments. More...
Protected Member Functions inherited from TCLAP::ValueArg< T >
void | _extractValue (const std::string &val)
| Extracts the value from the string. More...
Protected Member Functions inherited from TCLAP::Arg
void | _checkWithVisitor () const
| Performs the special handling described by the Visitor. More...
| Arg (const std::string &flag, const std::string &name, const std::string &desc, bool req, bool valreq, Visitor *v=NULL)
| Primary constructor. More...
Protected Attributes inherited from TCLAP::ValueArg< T >
T | _value
| The value parsed from the command line. More...
T | _default
| Used to support the reset() method so that ValueArg can be reset to their constructed value. More...
std::string | _typeDesc
| A human readable description of the type to be parsed. More...
Constraint< T > * | _constraint
| A Constraint this Arg must conform to. More...
Protected Attributes inherited from TCLAP::Arg
std::string | _flag
| The single char flag used to identify the argument. More...
std::string | _name
| A single word namd identifying the argument. More...
std::string | _description
| Description of the argument. More...
bool | _required
| Indicating whether the argument is required. More...
std::string | _requireLabel
| Label to be used in usage description. More...
bool | _valueRequired
| Indicates whether a value is required for the argument. More...
bool | _alreadySet
| Indicates whether the argument has been set. More...
Visitor * | _visitor
| A pointer to a visitor object. More...
bool | _ignoreable
| Whether this argument can be ignored, if desired. More...
bool | _xorSet
| Indicates that the arg was set as part of an XOR and not on the command line. More...
bool | _acceptsMultipleValues

## Detailed Description

### template<class T>
class TCLAP::UnlabeledValueArg< T >

The basic unlabeled argument that parses a value.

This is a template class, which means the type T defines the type that a given object will attempt to parse when an UnlabeledValueArg is reached in the list of args that the CmdLine iterates over.

Definition at line 46 of file UnlabeledValueArg.h.

## Constructor & Destructor Documentation

## ◆ UnlabeledValueArg() [1/4]

template<class T >

TCLAP::UnlabeledValueArg< T >::UnlabeledValueArg | ( | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | T | value,
|  | const std::string & | typeDesc,
|  | bool | ignoreable = `false`,
|  | Visitor * | v = `NULL`
| ) |  |

UnlabeledValueArg constructor.

Constructor implementation.

Parameters

  name | - A one word name for the argument. Note that this is used for identification, not as a long flag.
  desc | - A description of what the argument is for or does.
  req | - Whether the argument is required on the command line.
  value | - The default value assigned to this argument if it is not present on the command line.
  typeDesc | - A short, human readable description of the type that this object expects. This is used in the generation of the USAGE statement. The goal is to be helpful to the end user of the program.
  ignoreable | - Allows you to specify that this argument can be ignored if the '–' flag is set. This defaults to false (cannot be ignored) and should generally stay that way unless you have some special need for certain arguments to be ignored.
  v | - Optional Visitor. You should leave this blank unless you have a very good reason.

Definition at line 216 of file UnlabeledValueArg.h.

References TCLAP::Arg::_ignoreable, TCLAP::OptionalUnlabeledTracker::check(), and TCLAP::Arg::toString().

Here is the call graph for this function:

## ◆ UnlabeledValueArg() [2/4]

template<class T >

TCLAP::UnlabeledValueArg< T >::UnlabeledValueArg | ( | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | T | value,
|  | const std::string & | typeDesc,
|  | CmdLineInterface & | parser,
|  | bool | ignoreable = `false`,
|  | Visitor * | v = `NULL`
| ) |  |

UnlabeledValueArg constructor.

Parameters

  name | - A one word name for the argument. Note that this is used for identification, not as a long flag.
  desc | - A description of what the argument is for or does.
  req | - Whether the argument is required on the command line.
  value | - The default value assigned to this argument if it is not present on the command line.
  typeDesc | - A short, human readable description of the type that this object expects. This is used in the generation of the USAGE statement. The goal is to be helpful to the end user of the program.
  parser | - A CmdLine parser object to add this Arg to
  ignoreable | - Allows you to specify that this argument can be ignored if the '–' flag is set. This defaults to false (cannot be ignored) and should generally stay that way unless you have some special need for certain arguments to be ignored.
  v | - Optional Visitor. You should leave this blank unless you have a very good reason.

Definition at line 232 of file UnlabeledValueArg.h.

References TCLAP::Arg::_ignoreable, TCLAP::CmdLineInterface::add(), TCLAP::OptionalUnlabeledTracker::check(), and TCLAP::Arg::toString().

Here is the call graph for this function:

## ◆ UnlabeledValueArg() [3/4]

template<class T >

TCLAP::UnlabeledValueArg< T >::UnlabeledValueArg | ( | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | T | value,
|  | Constraint< T > * | constraint,
|  | bool | ignoreable = `false`,
|  | Visitor * | v = `NULL`
| ) |  |

UnlabeledValueArg constructor.

Constructor implementation.

Parameters

  name | - A one word name for the argument. Note that this is used for identification, not as a long flag.
  desc | - A description of what the argument is for or does.
  req | - Whether the argument is required on the command line.
  value | - The default value assigned to this argument if it is not present on the command line.
  constraint | - A pointer to a Constraint object used to constrain this Arg.
  ignoreable | - Allows you to specify that this argument can be ignored if the '–' flag is set. This defaults to false (cannot be ignored) and should generally stay that way unless you have some special need for certain arguments to be ignored.
  v | - Optional Visitor. You should leave this blank unless you have a very good reason.

Definition at line 251 of file UnlabeledValueArg.h.

References TCLAP::Arg::_ignoreable, TCLAP::OptionalUnlabeledTracker::check(), and TCLAP::Arg::toString().

Here is the call graph for this function:

## ◆ UnlabeledValueArg() [4/4]

template<class T >

TCLAP::UnlabeledValueArg< T >::UnlabeledValueArg | ( | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | T | value,
|  | Constraint< T > * | constraint,
|  | CmdLineInterface & | parser,
|  | bool | ignoreable = `false`,
|  | Visitor * | v = `NULL`
| ) |  |

UnlabeledValueArg constructor.

Parameters

  name | - A one word name for the argument. Note that this is used for identification, not as a long flag.
  desc | - A description of what the argument is for or does.
  req | - Whether the argument is required on the command line.
  value | - The default value assigned to this argument if it is not present on the command line.
  constraint | - A pointer to a Constraint object used to constrain this Arg.
  parser | - A CmdLine parser object to add this Arg to
  ignoreable | - Allows you to specify that this argument can be ignored if the '–' flag is set. This defaults to false (cannot be ignored) and should generally stay that way unless you have some special need for certain arguments to be ignored.
  v | - Optional Visitor. You should leave this blank unless you have a very good reason.

Definition at line 265 of file UnlabeledValueArg.h.

References TCLAP::Arg::_ignoreable, TCLAP::CmdLineInterface::add(), TCLAP::OptionalUnlabeledTracker::check(), and TCLAP::Arg::toString().

Here is the call graph for this function:

## Member Function Documentation

## ◆ addToList()

template<class T >

void TCLAP::UnlabeledValueArg< T >::addToList | ( | std::list< Arg * > & | argList | ) | const
| virtual

Instead of pushing to the front of list, push to the back.

Parameters

  argList | - The list to add this to.

Reimplemented from TCLAP::Arg.

Definition at line 337 of file UnlabeledValueArg.h.

## ◆ longID()

template<class T >

std::string TCLAP::UnlabeledValueArg< T >::longID | ( | const std::string & | val = `"val"` | ) | const
| virtual

Overrides longID for specific behavior.

Overriding longID for specific output.

Reimplemented from TCLAP::ValueArg< T >.

Definition at line 314 of file UnlabeledValueArg.h.

## ◆ operator==()

template<class T >

bool TCLAP::UnlabeledValueArg< T >::operator== | ( | const Arg & | a | ) | const
| virtual

Overrides operator== for specific behavior.

Overriding operator== for specific behavior.

Reimplemented from TCLAP::Arg.

Definition at line 328 of file UnlabeledValueArg.h.

References TCLAP::Arg::getDescription(), and TCLAP::Arg::getName().

Here is the call graph for this function:

## ◆ processArg()

template<class T >

bool TCLAP::UnlabeledValueArg< T >::processArg | ( | int * | i,
|  | std::vector< std::string > & | args
| ) |  |
| virtual

Handles the processing of the argument.

Implementation of processArg().

This re-implements the Arg version of this method to set the _value of the argument appropriately. Handling specific to unlabeled arguments.

Parameters

  i | - Pointer the the current argument in the list.
  args | - Mutable list of strings.

Reimplemented from TCLAP::ValueArg< T >.

Definition at line 284 of file UnlabeledValueArg.h.

## ◆ shortID()

template<class T >

std::string TCLAP::UnlabeledValueArg< T >::shortID | ( | const std::string & | val = `"val"` | ) | const
| virtual

Overrides shortID for specific behavior.

Overriding shortID for specific output.

Reimplemented from TCLAP::ValueArg< T >.

Definition at line 304 of file UnlabeledValueArg.h.

The documentation for this class was generated from the following file:

- UnlabeledValueArg.h